import es, popuplib, keyvalues, playerlib

ignorelist_ver = es.ServerVar("ignorelist_ver", "1.0", "The version of IgnoreList you are running.")
ignorelist_ver.makepublic()

def load():
    global ignorelist
    ignorelist = keyvalues.KeyValues(name="ignorelist")
    es.addons.registerSayFilter(say_filter)

def unload():
    es.server.cmd("est_Hook_Events_Matching none")
    if popuplib.exists('ignorelist'):
        popuplib.delete('ignorelist')
    es.addons.unregisterSayFilter(say_filter)

def round_start(event_var):
    es.msg("#multi", "#green[IgnoreList]#default Is someone really ticking you off? Type #lightgreen!ignore #defaultand add them to your ignore list.")

def say_filter(il_say_userid, il_say_text, il_say_team_only):
    message(il_say_userid, il_say_text, il_say_team_only)
    if il_say_text == '"!ignore"':
        ignorepopup(il_say_userid)
    return 0, '', il_say_team_only

def ignorepopup(il_userid):
    if popuplib.isqueued('ignorelist', il_userid):
        popuplib.close('ignorelist', il_userid)
    ignorelist = popuplib.easymenu('ignorelist', '_popup_choice', setignore)
    ignorelist.settitle('-IgnoreList v1.0-\n-Choose player to ignore-')
    for il_ignore_userid in playerlib.getPlayerList('#all'):
        if int(il_ignore_userid) != int(il_userid):
            il_ignore_name = es.getplayername(int(il_ignore_userid))
            ignorelist.addoption(int(il_ignore_userid), il_ignore_name)
    ignorelist.send(il_userid)

def setignore(il_userid, il_ignore_userid, il_popup):
    global ignorelist
    il_ignore_steam = es.getplayersteamid(il_ignore_userid)
    il_ignore_name = es.getplayername(il_ignore_userid)
    il_name = es.getplayername(il_userid)
    il_steam = es.getplayersteamid(il_userid)
    if not il_steam in ignorelist:
        ignorelist[il_steam] = keyvalues.KeyValues(name=il_steam)
    if il_ignore_steam in ignorelist[il_steam]:
        il_ignored = ignorelist[il_steam][il_ignore_steam]
    else:
        il_ignored = 0
    if il_ignored == 0:
        ignorelist[il_steam][il_ignore_steam] = 1
        es.tell(int(il_userid), "#multi", "#green[IgnoreList]#lightgreen %s #defaulthas been added to your ignore list." % il_ignore_name)
        es.tell(int(il_ignore_userid), "#multi", "#green[IgnoreList]#lightgreen %s #defaulthas added you to their ignore list." % il_name)
    else:
        ignorelist[il_steam][il_ignore_steam] = 0
        es.tell(int(il_userid), "#multi", "#green[IgnoreList]#lightgreen %s #defaulthas been removed from your ignore list." % il_ignore_name)
        es.tell(int(il_ignore_userid), "#multi", "#green[IgnoreList]#lightgreen %s #defaulthas removed you from their ignore list." % il_name)

def message(il_say_userid, il_say_text, il_say_team_only):
    global ignorelist
    il_say_text = il_say_text.strip('"')
    il_say_player = playerlib.getPlayer(il_say_userid)
    il_say_player_steam = il_say_player.attributes['steamid']
    il_say_steam_user = il_say_player.attributes['steamid']
    il_say_player_name = il_say_player.attributes['name']
    il_say_player_index = il_say_player.attributes['index']
    il_say_player_dead = il_say_player.attributes['isdead']
    il_say_player_team = il_say_player.attributes['teamid']
    il_say_player_format = "\1\3" + il_say_player_name + "\1 :  "
    if il_say_team_only == 0:
        if il_say_player_team == 1:
            il_say_player_format = "\1*SPEC* \3" + il_say_player_name + "\1 :  "
        if il_say_player_dead == 1 and il_say_player_team != 1:
            il_say_player_format = "\1*DEAD* \3" + il_say_player_name + "\1 :  "
    else:
        if il_say_player_team == 1:
            il_say_player_format = "\1(Specator) \3" + il_say_player_name + "\1 :  "
        if il_say_player_dead == 1 and il_say_player_team != 1:
            if il_say_player_team == 2:
                il_say_player_format = "\1*DEAD*(Terrorist) \3" + il_say_player_name + "\1 :  "
            if il_say_player_team == 3:
                il_say_player_format = "\1*DEAD*(Counter-Terrorist) \3" + il_say_player_name + "\1 :  "
        else:
            if il_say_player_team == 2:
                il_say_player_format = "\1(Terrorist) \3" + il_say_player_name + "\1 :  "
            if il_say_player_team == 3:
                il_say_player_format = "\1(Counter-Terrorist) \3" + il_say_player_name + "\1 :  "
    il_say_text = il_say_player_format + il_say_text
    es.usermsg('create','saytext2','SayText2')
    es.usermsg('write','byte','saytext2',il_say_player_index)
    es.usermsg('write','byte','saytext2',True) 
    es.usermsg('write','string','saytext2',il_say_text)
    es.usermsg('write','string','saytext2','')
    es.usermsg('write','string','saytext2','')
    es.usermsg('write','string','saytext2','')
    es.usermsg('write','string','saytext2','')
    if il_say_team_only == 0:
        if il_say_player_dead == 0:
            for il_say_userid in playerlib.getPlayerList('#all'):
                il_say_player = playerlib.getPlayer(il_say_userid)
                il_say_steam = il_say_player.attributes['steamid']
                if il_say_steam_user in ignorelist:
                    if il_say_steam in ignorelist[il_say_steam_user]:
                        il_ignored = ignorelist[il_say_steam_user][il_say_steam]
                        if il_ignored == 0:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))
                else:
                    if il_say_steam in ignorelist:
                        if il_say_steam_user in ignorelist[il_say_steam]:
                            il_ignored = ignorelist[il_say_steam][il_say_steam_user]
                            if il_ignored == 0:
                                es.usermsg('send','saytext2',int(il_say_userid))
                        else:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))

        if il_say_player_dead == 1:
            for il_say_userid in playerlib.getPlayerList('#dead'):
                il_say_player = playerlib.getPlayer(il_say_userid)
                il_say_steam = il_say_player.attributes['steamid']
                if il_say_steam_user in ignorelist:
                    if il_say_steam in ignorelist[il_say_steam_user]:
                        il_ignored = ignorelist[il_say_steam_user][il_say_steam]
                        if il_ignored == 0:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))
                else:
                    es.usermsg('send','saytext2',int(il_say_userid))
    else:
        if il_say_player_dead == 0:

            if il_say_player_team == 2:
                for il_say_userid in playerlib.getPlayerList('#t'):
                    il_say_player = playerlib.getPlayer(il_say_userid)
                    il_say_steam = il_say_player.attributes['steamid']
                    if il_say_steam_user in ignorelist:
                        if il_say_steam in ignorelist[il_say_steam_user]:
                            il_ignored = ignorelist[il_say_steam_user][il_say_steam]
                            if il_ignored == 0:
                                es.usermsg('send','saytext2',int(il_say_userid))
                        else:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))
            if il_say_player_team == 3:
                for il_say_userid in playerlib.getPlayerList('#ct'):
                    il_say_player = playerlib.getPlayer(il_say_userid)
                    il_say_steam = il_say_player.attributes['steamid']
                    if il_say_steam_user in ignorelist:
                        if il_say_steam in ignorelist[il_say_steam_user]:
                            il_ignored = ignorelist[il_say_steam_user][il_say_steam]
                            if il_ignored == 0:
                                es.usermsg('send','saytext2',int(il_say_userid))
                        else:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))
        if il_say_player_dead == 1:
            if il_say_player_team == 1:
                for il_say_userid in playerlib.getPlayerList('#spec'):
                    il_say_player = playerlib.getPlayer(il_say_userid)
                    il_say_steam = il_say_player.attributes['steamid']
                    if il_say_steam_user in ignorelist:
                        if il_say_steam in ignorelist[il_say_steam_user]:
                            il_ignored = ignorelist[il_say_steam_user][il_say_steam]
                            if il_ignored == 0:
                                es.usermsg('send','saytext2',int(il_say_userid))
                        else:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))
            if il_say_player_team == 2:
                for il_say_userid in playerlib.getPlayerList('#t,#dead'):
                    il_say_player = playerlib.getPlayer(il_say_userid)
                    il_say_steam = il_say_player.attributes['steamid']
                    if il_say_steam_user in ignorelist:
                        if il_say_steam in ignorelist[il_say_steam_user]:
                            il_ignored = ignorelist[il_say_steam_user][il_say_steam]
                            if il_ignored == 0:
                                es.usermsg('send','saytext2',int(il_say_userid))
                        else:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))
            if il_say_player_team == 3:
                for il_say_userid in playerlib.getPlayerList('#ct,#dead'):
                    il_say_player = playerlib.getPlayer(il_say_userid)
                    il_say_steam = il_say_player.attributes['steamid']
                    if il_say_steam_user in ignorelist:
                        if il_say_steam in ignorelist[il_say_steam_user]:
                            il_ignored = ignorelist[il_say_steam_user][il_say_steam]
                            if il_ignored == 0:
                                es.usermsg('send','saytext2',int(il_say_userid))
                        else:
                            es.usermsg('send','saytext2',int(il_say_userid))
                    else:
                        es.usermsg('send','saytext2',int(il_say_userid))
    es.usermsg('delete','saytext2')